# black template

## Objective

Run [Black](https://github.com/psf/black) on your Python code to ensure it complies with the coding
style guide. Black is configured with `--check --diff --quiet` rules.

## How to use it

1. Configure the black section of `pyproject.toml` in your repository's with your desired rules.
2. Include the Black template in your CI/CD configuration (see quick use above).
3. If you need to customize the job, check
   the [jobs customization](https://docs.r2devops.io/get-started/use-templates/#job-templates-customization).

## Variables

| Name                | Description                                                                                                                                                   | Default                              |
|---------------------|---------------------------------------------------------------------------------------------------------------------------------------------------------------|--------------------------------------|
| `PROJECT_PATH`      | The path to the project root directory.                                                                                                                       | `"."`                                |
| `IMAGE_TAG`         | The default tag for the docker image. See [Python Docker Official Image](https://hub.docker.com/_/python) for supported tags and respective Dockerfile links. | `"latest"`                           |
| `PYTHON_SETUP`      | Bash commands to setup your python environment.                                                                                                               | `"pip install black"`                |

## Global Configuration of Black

To add configuration to `black` shared with any other usage of black (such as manual run,
pre-commit, etc), you can use `pyproject.toml` configuration file. Learn more
about [pyproject](https://pip.pypa.io/en/stable/reference/build-system/pyproject-toml/)
configuration files.

## Add a [![Black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black) badge to your project README.md

To display the use of Black in your project, you can add the following badge to your README.md:

```markdown
[![Black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)
```
